import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Scanner;
import java.util.Vector;


public class Sequence {
	public static void main(String[] args) throws Exception {
		new Sequence().run();
	}

	private void run() throws Exception {
		Scanner sc = new Scanner(new File("sequence.in"));
		PrintWriter out = new PrintWriter(System.out);
		int testn = sc.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int a = sc.nextInt();
			if (a < 0 || a > 1000000000)
				throw new Exception("A out of bounds. Test:" + testi);
			
			int n = sc.nextInt();
			if (n < 0 || n > 1000000000)
				throw new Exception("N out of bounds. Test:" + testi);
			
			HashMap<Integer, Integer> map = new HashMap<Integer , Integer>();
			Vector<Integer> v = new Vector<Integer>();
			int count = 0;
			map.put(a, count++);
			v.add(a);
			while (true)
			{
				int s = 0;
				while (a > 0)
				{
					s += (a % 10)*(a % 10);
					a /= 10;
				}
				a = s;
				if (map.containsKey(a))
				{
					break;
				}
				else
				{
					map.put(a, count++);
					v.add(a);
				}
			}
			
			if (n < count)
			{
				out.println(v.get(n));
			}
			else
			{
				int start = map.get(a);
				if (start > 0)
					n -= start;
				n %= count - start;
				out.println(v.get(start + n));
			}
		}
		sc.close();
		out.close();
	}
	
	private void run1() throws IOException {
		Scanner sc = new Scanner(new File("sequence.in"));
		PrintWriter out = new PrintWriter("sequence.out");
		int testn = sc.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int a = sc.nextInt();
			int n = sc.nextInt();
			
			for (int i = 0; i < n; i++)
			{
				int s = 0;
				while (a > 0)
				{
					s += (a % 10)*(a % 10);
					a /= 10;
				}
				a = s;
			}
			out.println(a);
		}
		sc.close();
		out.close();
	}
}
